<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <a class="navbar-brand ml-5 mr-5" style="color:white;">Products</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarColor02"
        aria-controls="navbarColor02" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarColor02">
        <ul class="navbar-nav ml-auto mr-5">
            <li class="nav-item active" *ngIf="admin">
                <a class="nav-link ml-5 mr-5" (click)="onOpenModal(null, 'add')">Add product<span
                        class="sr-only">(current)</span></a>
            </li>
            <li class="nav-item" *ngIf="isLogged">
                <a class="nav-link mr-5" (click)="onLogOut()">Cerrar sesión<span class="sr-only">(current)</span></a>
            </li>
        </ul>
        <form class="form-inline my-2 my-lg-0 mr-2 ml-5">
            <input type="search" (ngModelChange)="searchProducts(key.viewModel)" #key="ngModel" ngModel name="key"
                id="searchName" class="form-control mr-sm-2" placeholder="Search products..." required>
        </form>
    </div>
</nav>

<div class="container" id="main-container">
    <div class="row">
        <div *ngFor="let product of products" class="col-md-6 col-xl-3">
            <div class="card m-b-30">

                <div class="card-body row">
                    <div class="col-6">
                        <a href=""><img src="{{product?.imageUrl}}" alt="" class="img-fluid rounded-circle w-60"></a>
                    </div>

                    <div class="col-6 card-title align-self-center mb-0">
                        <h5>{{product?.name}}</h5>
                        <p class="m-0">{{product?.description}}</p>
                    </div>
                </div>

                <ul class="list-group list-group-flush">
                    <li class="list-group-item"><i class="fa fa-envelope float-right"></i>Price: ${{product?.price}}
                    </li>
                    <li class="list-group-item"><i class="fa fa-envelope float-right"></i>Stock: {{product?.stock}}
                        unidades</li>
                    <li class="list-group-item"><i class="fa fa-phone float-right"></i>Product Code:
                        {{product?.productCode?.substr(0,7)}} ..</li>
                </ul>

                <div class="card-body">
                    <div class="float-right btn-group btn-group-sm">
                        <a (click)="onOpenModal(product, 'detail')" class="btn btn-primary tooltips mr-1"
                            data-placement="top" data-original-title="Detail"><i class="fa fa-eye"></i></a>
                        <a *ngIf="admin" (click)="onOpenModal(product, 'edit')" class="btn btn-primary tooltips mr-1"
                            data-placement="top" data-original-title="Edit"><i class="fa fa-pencil"></i> </a>
                        <a *ngIf="admin" (click)="onOpenModal(product, 'delete')" class="btn btn-secondary tooltips"
                            data-placement="top" data-original-title="Delete"><i class="fa fa-times"></i></a>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>

<!-- Add product Modal -->
<div class="modal fade" id="addProductModal" tabindex="-1" role="dialog" aria-labelledby="addProductModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="addProductModalLabel">Add product</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form #addForm="ngForm" (ngSubmit)="onAddProducts(addForm)">
                    <div class="form-group">
                        <label for="name">Name</label>
                        <input type="text" ngModel name="name" class="form-control" id="name" placeholder="Name"
                            required>
                    </div>
                    <div class="form-group">
                        <label for="description">Description</label>
                        <input type="text" ngModel name="description" class="form-control" id="description"
                            placeholder="Description" required>
                    </div>
                    <div class="form-group">
                        <label for="price">Price</label>
                        <input type="number" ngModel name="price" class="form-control" id="price" placeholder="Price"
                            required>
                    </div>
                    <div class="form-group">
                        <label for="stock">Stock</label>
                        <input type="number" ngModel name="stock" class="form-control" id="stock" placeholder="stock"
                            required>
                    </div>
                    <div class="form-group">
                        <label for="imageUrl">Image URL</label>
                        <input type="text" ngModel name="imageUrl" class="form-control" id="imageUrl"
                            placeholder="Image URL" required>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="add-product-form" class="btn btn-secondary"
                            data-dismiss="modal">Close</button>
                        <button [disabled]="addForm.invalid" type="submit" class="btn btn-primary">Save changes</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

<!-- Edit Modal -->
<div class="modal fade" id="updateProductModal" tabindex="-1" role="dialog" aria-labelledby="productEditModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="updateProductModalLabel">Edit product - {{editProduct?.name}}</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form #editForm="ngForm">
                    <div class="form-group">
                        <label for="name">Name</label>
                        <input type="text" ngModel="{{editProduct?.name}}" name="name" class="form-control" id="name"
                            aria-describedby="emailHelp" placeholder="Name">
                    </div>
                    <input type="hidden" ngModel="{{editProduct?.id}}" name="id" class="form-control" id="id"
                        placeholder="Id">
                    <input type="hidden" ngModel="{{editProduct?.productCode}}" name="userCode" class="form-control"
                        id="userCode" placeholder="userCode">
                    <div class="form-group">
                        <label for="description">Description</label>
                        <input type="text" ngModel="{{editProduct?.description}}" name="description"
                            class="form-control" id="description" placeholder="description">
                    </div>
                    <div class="form-group">
                        <label for="price">Price</label>
                        <input type="number" ngModel="{{editProduct?.price}}" name="price" class="form-control"
                            id="price" placeholder="Price">
                    </div>
                    <div class="form-group">
                        <label for="stock">Stock</label>
                        <input type="number" ngModel="{{editProduct?.stock}}" name="stock" class="form-control"
                            id="stock" placeholder="Stock">
                    </div>
                    <div class="form-group">
                        <label for="imageUrl">Image URL</label>
                        <input type="text" ngModel="{{editProduct?.imageUrl}}" name="imageUrl" class="form-control"
                            id="imageUrl" placeholder="Image URL">
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="" data-dismiss="modal" class="btn btn-secondary">Close</button>
                        <button (click)="onUpdateProduct(editForm, editForm.value)" data-dismiss="modal"
                            class="btn btn-primary">Save changes</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

<!-- Detail Modal -->
<div class="modal fade" id="detailProductModal" tabindex="-1" role="dialog" aria-labelledby="productDetailModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="detailProductModalLabel">Product detail - {{detailProduct?.name}}</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>

            <div class="modal-body">
                <div class="card m-b-30">

                    <div class="card-body row">
                        <div class="col-6">
                            <a href=""><img src="{{detailProduct?.imageUrl}}" alt=""
                                    class="img-fluid rounded-circle w-60"></a>
                        </div>

                        <div class="col-6 card-title align-self-center mb-0">
                            <h5>{{detailProduct?.name}}</h5>
                            <p class="m-0">{{detailProduct?.description}}</p>
                        </div>
                    </div>

                    <ul class="list-group list-group-flush">
                        <li class="list-group-item"><i class="fa fa-envelope float-right"></i>Price:
                            ${{detailProduct?.price}}
                        </li>
                        <li class="list-group-item"><i class="fa fa-envelope float-right"></i>Stock:
                            {{detailProduct?.stock}} unidades</li>
                    </ul>
                </div>

                <div class="card-body">
                    <p class="m-0"><i class="fa fa-phone float-right"></i>Product Code:
                        {{detailProduct?.productCode?.substr(0,25)}} ..</p>
                </div>

                <div class="modal-footer">
                    <button type="button" id="" data-dismiss="modal" class="btn btn-secondary">Close</button>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Delete Modal -->
<div class="modal fade" id="deleteProductModal" tabindex="-1" role="dialog" aria-labelledby="deleteModelLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="deleteModelLabel">Delete product</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <p>Are you sure you want to delete product {{deleteProduct?.name}}?</p>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">No</button>
                    <button (click)="onDeleteProduct(deleteProduct?.id)" class="btn btn-danger"
                        data-dismiss="modal">Yes</button>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Notification for no products -->
<div *ngIf="products?.length == 0" class="col-lg-12 col-md-12 col-xl-12">
    <div class="alert alert-info" role="alert">
        <h4 class="alert-heading">NO productS!</h4>
        <p>No products were found.</p>
    </div>
</div>